diff -uNr src/main/groovy/org/gradle/api/tasks/ide/eclipse/EclipseProject.java /home/phil/downloads/gradle-0.4-src.phil/src/main/groovy/org/gradle/api/tasks/ide/eclipse/EclipseProject.java
--- src/main/groovy/org/gradle/api/tasks/ide/eclipse/EclipseProject.java	2008-08-28 11:47:26.000000000 +0100
+++ /home/phil/downloads/gradle-0.4-src.phil/src/main/groovy/org/gradle/api/tasks/ide/eclipse/EclipseProject.java	2008-10-08 16:10:15.000000000 +0100
@@ -83,8 +83,10 @@
     }
 
     private void addNatures(Element root) {
-        Element buildCommand = root.addElement("buildSpec").addElement("buildCommand");
+        Element buildRoot = root.addElement("buildSpec");
+
         for (String buildCommandName : projectType.buildCommandNames()) {
+            Element buildCommand = buildRoot.addElement("buildCommand");
             buildCommand.addElement("name").setText(buildCommandName);
             buildCommand.addElement("arguments");
         }
diff -uNr src/main/groovy/org/gradle/api/tasks/ide/eclipse/EclipseUtil.java /home/phil/downloads/gradle-0.4-src.phil/src/main/groovy/org/gradle/api/tasks/ide/eclipse/EclipseUtil.java
--- src/main/groovy/org/gradle/api/tasks/ide/eclipse/EclipseUtil.java	2008-10-13 10:42:04.000000000 +0100
+++ /home/phil/downloads/gradle-0.4-src.phil/src/main/groovy/org/gradle/api/tasks/ide/eclipse/EclipseUtil.java	2008-10-13 10:33:46.000000000 +0100
@@ -59,6 +59,7 @@
     static void addFacet(Document document, String facetType, Attribute... attributes)
     {
 	Element root;
+
 	if(document.getRootElement() == null || (root = ((Element) document.selectSingleNode("//faceted-project"))) == null)
 	{
 		root = 	document.addElement("faceted-project");
diff -uNr src/main/groovy/org/gradle/api/tasks/ide/eclipse/EclipseWtpModule.java /home/phil/downloads/gradle-0.4-src.phil/src/main/groovy/org/gradle/api/tasks/ide/eclipse/EclipseWtpModule.java
--- src/main/groovy/org/gradle/api/tasks/ide/eclipse/EclipseWtpModule.java	2008-10-13 10:42:04.000000000 +0100
+++ /home/phil/downloads/gradle-0.4-src.phil/src/main/groovy/org/gradle/api/tasks/ide/eclipse/EclipseWtpModule.java	2008-10-08 10:43:16.000000000 +0100
@@ -116,7 +116,10 @@
     private void addResourceMappings(Element wbModule) {
         for(Object srcDir : getSrcDirs())
 	{
-		wbModule.addElement("wb-resource").addAttribute("deploy-path", "/").addAttribute("source-path", EclipseUtil.relativePath(getProject(), srcDir.toString()));
+		if(getProject().file(srcDir.toString()).exists())
+		{
+			wbModule.addElement("wb-resource").addAttribute("deploy-path", "/").addAttribute("source-path", EclipseUtil.relativePath(getProject(), srcDir.toString()));
+		}
 	}
     }	
 
